/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.9 Revision 1.19
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.9 2003/02/28 09:15:04 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.19 2005/09/02 08:23:30 azarah Exp $
4# 4#
5# Author: Diego Pettenò <flameeyes@gentoo.org>
5# Author: Martin Schlemmer <azarah@gentoo.org> 6# Enhancements: Martin Schlemmer <azarah@gentoo.org>
6# 7#
7# The autotools eclass enables building of the apps that needs the latest autconf/automake. 8# This eclass is for handling autotooled software packages that
9# needs to regenerate their build scripts.
8# 10#
9# NOTES: 11# NB: If you add anything, please comment it!
12
13inherit eutils gnuconfig
14
15#DEPEND="sys-devel/automake
16# sys-devel/autoconf
17# sys-devel/libtool"
10# 18#
11# This eclass was made to bridge the incompadibility problem of autoconf-2.13, 19# Ebuilds should rather depend on the proper version of the tool.
12# autoconf-2.5x and automake-1.4x, automake-1.5x. Most packages needs 20
13# autoconf-2.13 and automake-1.4x, but cannot work with the latest versions 21# Variables:
14# of these packages due to incompadibility, thus when we have a package that
15# needs the latest versions of automake and autoconf, it begins to get a
16# problem.
17# 22#
23# AT_M4DIR - Additional director(y|ies) aclocal should search
24# AT_GNUCONF_UPDATE - Should gnuconfig_update() be run (normally handled by
25# econf()) [yes|no]
26
27# Functions:
18# 28#
19# Commented Example: 29# eautoreconf() - Should do a full autoreconf - normally what most people
20# 30# will be interested in. Also should handle additional
21# The following is a commented template for how to use this eclass: 31# directories specified by AC_CONFIG_SUBDIRS.
22# 32# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
23# #<cut here> 33# to search for macro's.
24# # Copyright 1999-2002 Gentoo Technologies, Inc. 34# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
25# # Distributed under the terms of the GNU General Public License, v2 or later 35# with elibtoolize() from libtool.eclass
26# # Maintainer: John Doe <john@foo.com> 36# eautoconf - Runs autoconf.
27# # $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.9 2003/02/28 09:15:04 vapier Exp $ 37# eautoheader - Runs autoheader.
28# 38# eautomake - Runs automake
29# # If you need to set the versions different from in here, it *must*
30# # be done before inherit.eclass is sourced
31# #ACONFVER=2.52f
32# #AMAKEVER=1.5b
33#
34# # Source inherit.eclass and inherit AutoTools
35# . /usr/portage/eclass/inherit.eclass
36# inherit autotools
37#
38# # This is pretty standard.
39# S=${WORKDIR}/${P}
40# DESCRIPTION="My Application"
41#
42# # Here you *NEED* to have $SRC_URI as a source url to include the automake
43# # and autoconf source tarballs
44# SRC_URI="${SRC_URI}
45# http://download.foo.com/files/${P}.tar.gz"
46#
47# HOMEPAGE="http://www.foo.com/"
48#
49# # Here you *NEED* to have "$DEPEND" as an depend to include the dependancies
50# # of automake and autoconf.
51# DEPEND="${DEPEND}
52# foo-libs/libfoo"
53#
54# src_compile() {
55#
56# # This will install automake and autoconf in a tempory directory and
57# # setup the environment. Do not forget!!!!!!!
58# install_autotools
59#
60# # Now like normal
61# ./configure --host=${CHOST} \
62# --prefix=/usr || die
63# emake || die
64# }
65#
66# src_install() {
67#
68# # Still pretty standard to how you would normally do it
69# make DESTDIR=${D} install || die
70# dodoc AUTHORS COPYING ChangeLog INSTALL NEWS README TODO
71# }
72# #<cut here>
73# 39#
74 40
75 41# XXX: M4DIR should be depreciated
76ECLASS=autotools 42AT_M4DIR=${AT_M4DIR:-${M4DIR}}
77INHERITED="$INHERITED $ECLASS" 43AT_GNUCONF_UPDATE="no"
78
79#[ -z "$ACONFVER" ] && ACONFVER=2.52f
80#[ -z "$AMAKEVER" ] && AMAKEVER=1.5b
81[ -z "$ACONFVER" ] && die "!!! You need to set \$ACONFVER *before* inheriting the eclass !!!"
82[ -z "$AMAKEVER" ] && die "!!! You need to set \$AMAKEVER *before* inheriting the eclass !!!"
83
84DESCRIPTION="Based on the $ECLASS eclass"
85#ASRC_URI="ftp://ftp.gnu.org/gnu/autoconf/autoconf-${ACONFVER}.tar.bz2
86# ftp://alpha.gnu.org/gnu/autoconf/autoconf-${ACONFVER}.tar.bz2
87# ftp://ftp.gnu.org/gnu/automake/automake-${AMAKEVER}.tar.bz2
88# ftp://alpha.gnu.org/gnu/automake/automake-${AMAKEVER}.tar.bz2"
89SRC_URI="ftp://ftp.gnu.org/gnu/autoconf/autoconf-${ACONFVER}.tar.bz2
90 ftp://alpha.gnu.org/gnu/autoconf/autoconf-${ACONFVER}.tar.bz2
91 ftp://ftp.gnu.org/gnu/automake/automake-${AMAKEVER}.tar.bz2
92 ftp://alpha.gnu.org/gnu/automake/automake-${AMAKEVER}.tar.bz2"
93
94DEPEND="sys-devel/make
95 sys-devel/perl
96 >=sys-devel/m4-1.4o-r2"
97 44
98 45
99AUTO_S="${WORKDIR}" 46# This function mimes the behavior of autoreconf, but uses the different
100AUTO_D="${T}/autotools" 47# eauto* functions to run the tools. It doesn't accept parameters, but
48# the directory with include files can be specified with AT_M4DIR variable.
49#
50# Note: doesn't run autopoint right now, but runs gnuconfig_update.
51eautoreconf() {
52 local pwd=$(pwd) x
101 53
102fetch_autotools() { 54 # Take care of subdirs
55 for x in $(autotools_get_subdirs); do
56 if [[ -d ${x} ]] ; then
57 cd "${x}"
58 eautoreconf
59 cd "${pwd}"
60 fi
61 done
103 62
104 local y 63 eaclocal
105 for y in ${ASRC_URI} 64 _elibtoolize --copy --force
106 do 65 eautoconf
107 if [ ! -e ${DISTDIR}/${y##*/} ] 66 eautoheader
108 then 67 eautomake
109 echo ">>> Fetching ${y##*/}..." 68
110 echo 69 # Normally run by econf()
111 local x 70 [[ ${AT_GNUCONF_UPDATE} == "yes" ]] && gnuconfig_update
112 local _SRC_URI
113 for x in ${GENTOO_MIRRORS}
114 do
115 _SRC_URI="${_SRC_URI} ${x}/distfiles/${y##*/}"
116 done
117 _SRC_URI="${_SRC_URI} `queryhost.sh "${SRC_URI}"`"
118 for x in ${_SRC_URI}
119 do
120 if [ ! -e ${DISTDIR}/${y##*/} ]
121 then
122 if [ "${y##*/}" = "${x##*/}" ]
123 then
124 echo ">>> Trying site ${x}..."
125 eval "${FETCHCOMMAND}"
126 fi
127 fi
128 done
129 if [ ! -e ${DISTDIR}/${y##*/} ]
130 then
131 echo '!!!'" Couldn't download ${y##*/} needed by autotools.eclass. Aborting."
132 exit 1
133 fi
134 echo
135 fi
136 done
137} 71}
138 72
139unpack_autotools() { 73# These functions runs the autotools using autotools_run_tool with the
74# specified parametes. The name of the tool run is the same of the function
75# without e prefix.
76# They also force installing the support files for safety.
77eaclocal() {
78 local aclocal_opts
140 79
141 cd ${AUTO_S} 80 # XXX: M4DIR should be depreciated
81 AT_M4DIR=${AT_M4DIR:-${M4DIR}}
142 82
143 local x 83 if [[ -n ${AT_M4DIR} ]] ; then
144 for x in ${ASRC_URI} 84 for x in ${AT_M4DIR} ; do
145 do 85 case "${x}" in
146 unpack ${x##*/} || die "!!! Could not unpack ${x##*/} needed by autotools !!!" 86 "-I")
87 # We handle it below
88 ;;
89 "-I"*)
90 # Invalid syntax, but maybe we should help out ...
91 ewarn "eaclocal: Proper syntax is (note the space after '-I'): aclocal -I <dir>"
92 aclocal_opts="${aclocal_opts} -I ${x}"
93 ;;
94 *)
95 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
96 aclocal_opts="${aclocal_opts} -I ${x}"
97 ;;
98 esac
147 done 99 done
100 fi
101
102 [[ -f aclocal.m4 && -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
103 autotools_run_tool aclocal "$@" ${aclocal_opts}
148} 104}
149 105
150install_autoconf() { 106_elibtoolize() {
107 local opts
108
109 # Check if we should run libtoolize
110 [[ -n $(autotools_check_macro "AC_PROG_LIBTOOL") ]] || return 0
151 111
152 cd ${AUTO_S}/autoconf-${ACONFVER} || die "!!! Failed to build autoconf !!!" 112 [[ -f Makefile.am ]] && opts="--automake"
113
114 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize"
115 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts}
153 116
154 ./configure --prefix=${AUTO_D} \ 117 # Need to rerun aclocal
155 --infodir=${AUTO_D}/share/info \ 118 eaclocal
156 --mandir=${AUTO_D}/share/man \
157 --target=${CHOST} || die "!!! Failed to configure autoconf !!!"
158
159 emake || die "!!! Failed to build autoconf !!!"
160
161 make install || die "!!! Failed to install autoconf !!!"
162} 119}
163 120
164install_automake() { 121eautoheader() {
165 122 # Check if we should run autoheader
166 cd ${AUTO_S}/automake-${AMAKEVER} || die "!!! Failed to build automake !!!" 123 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
167 124 autotools_run_tool autoheader "$@"
168 ./configure --prefix=${AUTO_D} \
169 --infodir=${AUTO_D}/share/info \
170 --mandir=${AUTO_D}/share/man \
171 --target=${CHOST} || die "!!! Failed to configure automake !!!"
172
173 emake || die "!!! Failed to build automake !!!"
174
175 make install || die "!!! Failed to install automake !!!"
176} 125}
177 126
178install_autotools() { 127eautoconf() {
179 128 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
180 if [ "${SRC_URI/autoconf/}" = "$SRC_URI" ] || [ "${SRC_URI/automake/}" = "$SRC_URI" ] 129 echo
181 then 130 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!"
182 echo "!!! \$SRC_URI was not set properly !!! It needs to include \${SRC_URI}" 131 echo
183 exit 1 132 die "No configure.{ac,in} present!"
184 fi 133 fi
185 134
186 if [ "${DEPEND/make/}" = "$DEPEND" ] || [ "${DEPEND/perl/}" = "$DEPEND" ] || \ 135 autotools_run_tool autoconf "$@"
187 [ "${DEPEND/m4/}" = "$DEPEND" ]
188 then
189 echo "!!! \$DEPEND was not set properly !!! It needs to include \${DEPEND}"
190 exit 1
191 fi
192
193 mkdir -p ${AUTO_S}
194 mkdir -p ${AUTO_D}/{bin,etc,lib,include,share} \
195 || die "!!! Could not create needed directories for autotools !!!"
196
197# fetch_autotools
198# unpack_autotools
199 install_autoconf
200 install_automake
201
202 export PATH=${AUTO_D}/bin:${PATH}
203 cd ${S}
204 ln -sf ${AUTO_D}/share/automake/depcomp ${S}/depcomp
205} 136}
206 137
138eautomake() {
139 [[ -f Makefile.am ]] || return 0
140 # --force-missing seems not to be recognized by some flavours of automake
141 autotools_run_tool automake --add-missing --copy "$@"
142}
143
144
145
146# Internal function to run an autotools' tool
147autotools_run_tool() {
148 local STDERR_TARGET="${T}/$$.out"
149 local PATCH_TARGET="${T}/$$.patch"
150 local ris
151
152 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
153 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}
154
155 ebegin "Running $1"
156 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1
157 ris=$?
158 eend ${ris}
159
160 if [[ ${ris} != 0 ]]; then
161 echo
162 eerror "Failed Running $1 !"
163 eerror
164 eerror "Include in your bugreport the contents of:"
165 eerror
166 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}"
167 echo
168 die "Failed Running $1 !"
169 fi
170}
171
172# Internal function to check for support
173autotools_check_macro() {
174 [[ -f configure.ac || -f configure.in ]] && \
175 autoconf --trace=$1 2>/dev/null
176 return 0
177}
178
179# Internal function to get additional subdirs to configure
180autotools_get_subdirs() {
181 local subdirs_scan_out
182
183 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS")
184 [[ -n ${subdirs_scan_out} ]] || return 0
185
186 echo "${subdirs_scan_out}" | gawk \
187 '($0 !~ /^[[:space:]]*(#|dnl)/) {
188 if (match($0, "AC_CONFIG_SUBDIRS\\(\\[?([^\\])]*)", res)) {
189 split(res[1], DIRS, /[\])]/)
190 print DIRS[1]
191 }
192 }' | uniq
193
194 return 0
195}
196

Legend:
Removed from v.1.9  
changed lines
  Added in v.1.19

  ViewVC Help
Powered by ViewVC 1.1.20